From 676196b1fe2da5ca43a2bb41732cb0fb6fca6c10 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 00:36:42 +0000
Subject: [PATCH 1263/2232] Use interned strings in cfg implementation


---

diff --git a/gen/build/src/cfg.rs b/gen/build/src/cfg.rs
index e0186a3..d18a2c0 100644
--- a/gen/build/src/cfg.rs
+++ b/gen/build/src/cfg.rs
@@ -79,6 +79,7 @@ pub use self::r#impl::Cfg::CFG;
 
 #[cfg(not(doc))]
 mod r#impl {
+    use crate::intern::{intern, InternedString};
     use lazy_static::lazy_static;
     use std::cell::RefCell;
     use std::collections::HashMap;
@@ -88,12 +89,11 @@ mod r#impl {
     use std::sync::{PoisonError, RwLock};
 
     lazy_static! {
-        static ref PACKAGE_NAME: Box<str> = {
+        static ref INCLUDE_PREFIX: RwLock<InternedString> = RwLock::new({
             crate::env_os("CARGO_PKG_NAME")
-                .map(|pkg| pkg.to_string_lossy().into_owned().into_boxed_str())
+                .map(|pkg| intern(&pkg.to_string_lossy()))
                 .unwrap_or_default()
-        };
-        static ref INCLUDE_PREFIX: RwLock<Vec<&'static str>> = RwLock::new(vec![&PACKAGE_NAME]);
+        });
     }
 
     thread_local! {
@@ -117,11 +117,10 @@ mod r#impl {
 
     impl<'a> Cfg<'a> {
         fn current() -> super::Cfg<'a> {
-            let include_prefix = *INCLUDE_PREFIX
+            let include_prefix = INCLUDE_PREFIX
                 .read()
                 .unwrap_or_else(PoisonError::into_inner)
-                .last()
-                .unwrap();
+                .str();
             super::Cfg {
                 include_prefix,
                 marker: PhantomData,
@@ -184,10 +183,9 @@ mod r#impl {
     impl<'a> Drop for Cfg<'a> {
         fn drop(&mut self) {
             if let Cfg::Mut(cfg) = self {
-                INCLUDE_PREFIX
+                *INCLUDE_PREFIX
                     .write()
-                    .unwrap_or_else(PoisonError::into_inner)
-                    .push(Box::leak(Box::from(cfg.include_prefix)));
+                    .unwrap_or_else(PoisonError::into_inner) = intern(cfg.include_prefix);
             } else {
                 CONST_DEREFS.with(|derefs| derefs.borrow_mut().remove(&self.handle()));
             }
diff --git a/gen/build/src/intern.rs b/gen/build/src/intern.rs
index 800b8a3..51bc07c 100644
--- a/gen/build/src/intern.rs
+++ b/gen/build/src/intern.rs
@@ -2,7 +2,7 @@ use lazy_static::lazy_static;
 use std::collections::HashSet;
 use std::sync::{Mutex, PoisonError};
 
-#[derive(Copy, Clone)]
+#[derive(Copy, Clone, Default)]
 pub struct InternedString(&'static str);
 
 impl InternedString {

